// keygen by akacastor 2024-03-04 for Buccaneer version 2.10 by Cross Connect Software (BBS door game)
// creates BUCK.KEY
// note - if you don't want a BBS name, BUCK.KEY can be a file of 44 zeroes

#include <stdio.h>
#include <string.h>


// total length of BUCK.KEY is 44 bytes
#define BUCK_KEY_LEN    44

// maximum BBS name length is 34 - starts at buck_key[9] and leave room for NULL at the end
#define BBS_NAME_LEN    34


int main(int argc,char **argv)
{
    char buck_key[BUCK_KEY_LEN];
    FILE *key_file;
    char key_file_name[] = "BUCK.KEY";
    int checksum;
    int i;

    
    memset( buck_key, 0, BUCK_KEY_LEN );
    
    // get BBS name and fill buck_key[9]
    if( argc==2 )
        strncpy( buck_key+9, argv[1], BBS_NAME_LEN );
    else
    {
        printf( "Keyfile generator for Buccaneer version 2.10 by Cross Connect Software\n" );
        printf( "(keygen by akacastor 2024-03-04)\n\n" );
        printf( "usage: %s \"BBS name\"\n\n", argv[0] );
        printf( "Be sure to put quotes around the BBS name if it includes any spaces.\n" );
        printf( "BUCK.KEY will be created.\n" );
        return 1;
    }

    printf( "Creating '%s' for BBS: '%s'\n", key_file_name, buck_key+9 );

    // buck_key[8] set to length of BBS name
    buck_key[8] = strlen(buck_key+9);

    // buck_key[2] set to first byte of BBS name    
    buck_key[2] = buck_key[9];
    
    // buck_key[4] set to last byte of BBS name
    buck_key[4] = buck_key[8+buck_key[8]];

    checksum = buck_key[2];
    checksum += buck_key[4];
    for( i=0; i<buck_key[8]; i++ )
        checksum += buck_key[9+i];

    // buck_key[6] and [7] hold checksum value (little endian 16 bit word)
    buck_key[6] = checksum & 0xFF;
    buck_key[7] = (checksum>>8) & 0xFF;

    // write buck_key[] to BUCK.KEY file
    key_file = fopen( key_file_name, "wb" );
    if( !key_file )
    {
        printf( "error: unable to open '%s' for writing - aborting.\n", key_file_name );
        return 1;
    }    
    
    if( !fwrite( buck_key, BUCK_KEY_LEN, 1, key_file ) )
        printf( "error: unable to write '%s'.\n", key_file_name );
    
    fclose( key_file );
    
    
    return 0;
}
